
THLM_FILE_LOOTMOD2_SERVER_LUA = 1;

local THLM_ResultList = nil;
local THLM_SortType = "bid";
local THLM_SortAscending = true;
local THLM_ThisPrio = {};
local THLM_CurrentAuctionItemName = nil;

THLM_ClassOverrides = {};
local THLM_Classes = {
	warrior = "Warrior",
	paladin = "Paladin",
	priest = "Priest",
	druid = "Druid",
	rogue = "Rogue",
	mage = "Mage",
	warlock = "Warlock",
	hunter = "Hunter",
	shaman = "Shaman",
	spriest = "Shadow Priest",
	enshaman = "Enhancement Shaman",
	fdruid = "Feral Druid",
	fwarrior = "Fury Warrior",
};

THLM_CurrentReannounceTime = 0;
THLM_CurrentLastCallTime = 0;
THLM_NextVersionTime = 0;

THLM_REANNOUNCE_TIME = 15;
THLM_LASTCALL_TIME = 5;
THLM_VERSION_TIME = 60*3;

function THLM_StartBidOnLoot(index)
    if not (THLM_GetCurrentItemHyperlink() == nil) then
        THLM_Print("Can not start a new auction while one is already running!");
        return;
    end
    local numLootToShow = LOOTFRAME_NUMBUTTONS - 1;
    local slot = (numLootToShow * (LootFrame.page - 1)) + index;
    local item = GetLootSlotLink(slot);
    THLM_StartBidOnItem(item);
end

function THLM_StartBidOnItem(item)
    if not (THLM_GetCurrentItemHyperlink() == nil) then
        THLM_Print("Can not start a new auction while one is already running!");
        return;
    end
    if (not UnitInRaid("player")) or (not IsRaidLeader() and not IsRaidOfficer()) then
        THLM_Print("You must be leader or promoted to do that!");
        return;
    end

    THLM_SendVersion();

    local _, _, itemnum = string.find(item, "item:(%d+)");
    local name, _, rarity, _, _, _, _, _, _, tex = GetItemInfo(itemnum);
    local _, _, _, icolor = GetItemQualityColor(rarity);
    THLM_ResultFrameItemName:SetText(icolor..name);
    THLM_ResultFrameItemTexture:SetTexture(tex);

	THLM_CurrentAuctionItemName = name;
    THLM_ThisPrio = {};
    SendChatMessage(item .. THLM_AUCTIONSTART_SUFFIX, "RAID");
    if THLM_PriorityTable and THLM_PriorityTable[name] then
       THLM_SendPriorityInfo(name);
    end
    THLM_CurrentReannounceTime = GetTime() + THLM_AUCTION_TIME - THLM_REANNOUNCE_TIME;
    THLM_CurrentLastCallTime = GetTime() + THLM_AUCTION_TIME - THLM_LASTCALL_TIME;

    THLM_ResultList = {};
    THLM_SortType = "bid+prio";
    THLM_SortAscending = false;
    THLM_ResultListScroll();
    THLM_ResultFrame:Show();
end

function THLM_SendPriorityInfo(name)
    if not THLM_PriorityTable or not THLM_PriorityTable[name] then
       return;
    end

    local pentry = THLM_PriorityTable[name];
    THLM_ThisPrio = pentry;
    local msg = "";
    table.foreach(THLM_Classes, function(k,v)
		msg = msg .. THLM_GetClassPrio(pentry, k, v);
    end);
	--[[
    msg = msg .. THLM_GetClassPrio(pentry, "warrior", "Warrior");
    msg = msg .. THLM_GetClassPrio(pentry, "paladin", "Paladin");
    msg = msg .. THLM_GetClassPrio(pentry, "priest", "Priest");
    msg = msg .. THLM_GetClassPrio(pentry, "druid", "Druid");
    msg = msg .. THLM_GetClassPrio(pentry, "rogue", "Rogue");
    msg = msg .. THLM_GetClassPrio(pentry, "mage", "Mage");
    msg = msg .. THLM_GetClassPrio(pentry, "warlock", "Warlock");
    msg = msg .. THLM_GetClassPrio(pentry, "hunter", "Hunter");
    msg = msg .. THLM_GetClassPrio(pentry, "shaman", "Shaman");
    msg = msg .. THLM_GetClassPrio(pentry, "spriest", "Shadow Priest");
    msg = msg .. THLM_GetClassPrio(pentry, "enshaman", "Enhancement Shaman");
    msg = msg .. THLM_GetClassPrio(pentry, "fdruid", "Feral Druid");
    msg = msg .. THLM_GetClassPrio(pentry, "fwarrior", "Fury Warrior");
	--]]
    if not (msg == "") then
       msg = "Priority: " .. msg;
    else
       msg = "Priority: none";
    end
    SendChatMessage(msg, "RAID");
end

function THLM_SendVersion()
   --CT_RA_SendMessage("_THLM_VR "..THLM_VERSION);
   THCH_SendMessage("_THLM_VR "..THLM_VERSION, "GUILD");
   if (UnitInRaid("player")) then
       THCH_SendMessage("_THLM_VR "..THLM_VERSION, "RAID");
       -- XXX: Backwards compat only, remove after a couple versions
       SendAddonMessage("CTRA", "_THLM_VR "..THLM_VERSION, "RAID");
   end
end

function THLM_GetItemClassPrio(itemName, class, baseclass)
    local cprio = THLM_GetItemClassPrioInner(itemName, class);
	--[[
    local bcprio = THLM_GetItemClassPrioInner(itemName, baseclass);

	if cprio == "-" then
	    return bcprio;
	end
	if bcprio == "-" then
		return cprio;
	end
	local _, _, cval = string.find(""..cprio, "(%d+)");
	local _, _, bcval = string.find(""..bcprio, "(%d+)");
	if (bcval+0) < (cval+0) then
		return bcprio;
	end
	--]]
	return cprio;
end

function THLM_GetItemClassPrioInner(itemName, class)
	local pentry = THLM_PriorityTable[itemName];
	if not pentry then
		return "-";
	end
	local prio = pentry[class];
	if not prio then
		prio = "-";
	end
	return prio;
end

function THLM_GetClassPrio(pentry, key, short)
   local px = pentry[key];
   if px == "-" then
      return "";
   else
      local res = short .. ":" .. px .. " ";
      return res;
   end
end

function THLM_Test(x)
    THLM_StartBidOnItem(x);
end

function THLM_ResultColumnHeaderClick(sortType)
    if (THLM_SortType == sortType) then
        THLM_SortAscending = not THLM_SortAscending;
    else
        THLM_SortType = sortType;
        THLM_SortAscending = true;
    end
    THLM_ResultListScroll();
end

function THLM_GetPrioritySortNumeric(prio)
	if not prio then
		prio = "";
	end
	local _, _, nval = string.find(""..prio, "(%d+)");
	if not nval then
		nval = 99;
	end
	nval = 100 - nval;
	nval = nval * 100000;
	return nval;
end

function THLM_UpdateResultDisplay()
    THLM_ResultListScroll();
end

function THLM_ResultListScroll()
    --local numResults = 100;
    --local numResults = table.getn(THLM_ResultList);
    local listOffset = FauxScrollFrame_GetOffset(THLM_ResultFrameScrollFrame);

    local i = 1;
    local slist = {};
    table.foreach(THLM_ResultList, function(k,v)
        slist[i] = v;
        i = i + 1;
    end);
    table.sort(slist, function(a,b)
       if a==nil then return false; end
       if b==nil then return true; end
       local av = a[THLM_SortType];
       local bv = b[THLM_SortType];
	   if THLM_SortType == "bid+prio" then
	      local abid = a["bid"];
		  local bbid = b["bid"];
		  local aprio = THLM_GetItemClassPrio(THLM_CurrentAuctionItemName, string.lower(a["class"]), string.lower(a["baseclass"]));
		  local bprio = THLM_GetItemClassPrio(THLM_CurrentAuctionItemName, string.lower(b["class"]), string.lower(b["baseclass"]));
		  if aprio and not (aprio == "-") and (abid > 10) then
			 av = abid + THLM_GetPrioritySortNumeric(aprio);
		  else
		     av = abid;
		  end
		  if bprio and not (bprio == "-") and (abid > 10) then
			 bv = bbid + THLM_GetPrioritySortNumeric(bprio);
		  else
		     bv = bbid;
		  end
	   end
       if av==nil then return false; end
       if bv==nil then return true; end
       local res = av < bv;
       if THLM_SortAscending then
           return res;
       else
           return not res;
       end
    end);
    local numResults = table.getn(slist);
    --THLM_ResultFrameTitleFrameText:SetText(numResults);

    for i = 1, 20 do
        local rowNum = i + listOffset;
        local thisEl = slist[rowNum];
        if (rowNum <= numResults) then
            getglobal("THLM_ResultFrameRow"..i.."Name"):SetText(thisEl["name"]);
			local classStr = thisEl["class"];
			local baseclassStr = thisEl["baseclass"];
			local bidprio = THLM_GetItemClassPrio(THLM_CurrentAuctionItemName, string.lower(classStr), string.lower(baseclassStr));
			if THLM_Classes[string.lower(classStr)] then
				classStr = THLM_Classes[string.lower(classStr)];
			end
            getglobal("THLM_ResultFrameRow"..i.."Class"):SetText(bidprio.."- "..classStr);
            getglobal("THLM_ResultFrameRow"..i.."Bid"):SetText(thisEl["bid"]);
            if THLM_ThisPrio and THLM_ThisPrio[string.lower(thisEl["class"])] then
               local cpio = THLM_ThisPrio[string.lower(thisEl["class"])];
               if string.find(cpio, "1") then
                  getglobal("THLM_ResultFrameRow"..i.."Bid"):SetTextColor(0.0, 1.0, 0.0, 1.0);
               elseif string.find(cpio, "2") then
                  getglobal("THLM_ResultFrameRow"..i.."Bid"):SetTextColor(0.0, 1.0, 1.0, 1.0);
               elseif string.find(cpio, "3") then
                  getglobal("THLM_ResultFrameRow"..i.."Bid"):SetTextColor(1.0, 0.0, 0.0, 1.0);
               else
                  getglobal("THLM_ResultFrameRow"..i.."Bid"):SetTextColor(1.0, 1.0, 1.0, 1.0);
               end
            else
               getglobal("THLM_ResultFrameRow"..i.."Bid"):SetTextColor(1.0, 1.0, 1.0, 1.0);
            end
            if THLM_AllMinBids and THLM_AllMinBids[thisEl["name"]] then
               getglobal("THLM_ResultFrameRow"..i.."MinBid"):SetText(THLM_AllMinBids[thisEl["name"]]);
            else
               getglobal("THLM_ResultFrameRow"..i.."MinBid"):SetText("");
            end
            getglobal("THLM_ResultFrameRow"..i):Show();
        else
            getglobal("THLM_ResultFrameRow"..i):Hide();
        end
    end

    --FauxScrollFrame_Update(THLM_ResultFrameScrollFrame, numResults, 20, 16);
    FauxScrollFrame_Update(THLM_ResultFrameScrollFrame, numResults, 20, 20);
end

function THLM_CloseResultFrame()
    if (THLM_CurrentAuctioneer == UnitName("player")) then
        SendChatMessage(THLM_AUCTIONCANCEL_PREFIX..THLM_CurrentItem..THLM_AUCTIONCANCEL_SUFFIX, "RAID");
    end
    THLM_ResultFrame:Hide();
end

function THLM_ToggleLootButtons()
    if (LootFrame:IsVisible()) then
        local index;
        for index = 1,4 do
            if (getglobal("LootButton"..index):IsVisible() and UnitInRaid("player") and
                   (IsRaidLeader() or IsRaidOfficer()) ) then
                getglobal("THLM_RunBid"..index):Show();
            else
                getglobal("THLM_RunBid"..index):Hide();
            end
        end
    end
end

function THLM_OnUpdateServer()
    THLM_ToggleLootButtons();
    if (THLM_ResultFrame:IsVisible()) then
        local now = GetTime();
        if (THLM_CurrentExpireTime <= now) then
            THLM_ResultFrameTime:Hide();
        else
            local tl = THLM_CurrentExpireTime - now;
            tl = math.ceil(tl);
            THLM_ResultFrameTime:SetText("T:" .. tl .. "s");
            THLM_ResultFrameTime:Show();
        end
    end
    if (THLM_CurrentReannounceTime > 0) then
        local now = GetTime();
        if (now >= THLM_CurrentReannounceTime) then
            local item = THLM_CurrentItem;
            if item then
                SendChatMessage("Second call for "..item..", send tells now", "RAID");
            end
            THLM_CurrentReannounceTime = 0;
        end
    end
    if (THLM_CurrentLastCallTime > 0) then
        local now = GetTime();
        if (now >= THLM_CurrentLastCallTime) then
            local item = THLM_CurrentItem;
            if item then
                SendChatMessage("LAST CALL FOR "..item..", send tells now", "RAID");
            end
            THLM_CurrentLastCallTime = 0;
        end
    end
    if (THLM_NextVersionTime < GetTime()) then
       if (UnitInRaid("player")) then
          THLM_NextVersionTime = GetTime() + THLM_VERSION_TIME;
          THLM_SendVersion();
       else
          THLM_NextVersionTime = GetTime() + 5;
       end
    end
end

function THLM_GetClass(who, defaultClass)
	local overrideClass = nil;

    table.foreach(THLM_ClassOverrides, function(k,v)
		if v and v.name and v.class then
			if (v.name == who) then
				overrideClass = v.class;
			end
		end
    end);

	if overrideClass then
		return overrideClass;
	else
		return defaultClass;
	end
end

function THLM_ClearOverrideClass(who)
	if not who then
		return;
	end
	if not THLM_ClassOverrides[who] then
		THLM_Print(who.." does not have a class override set!");
		return;
	end

	THLM_ClassOverrides[who] = nil;
	THLM_Print("Class override cleared for "..who..".");
	if THLM_ResultFrame:IsVisible() then
		THLM_FixupBidClasses();
		THLM_UpdateResultDisplay();
	end
end

function THLM_SetOverrideClass(who, overrideClass)
	if not who then
		return;
	end
	if not overrideClass then
		THLM_ClearOverrideClass(who);
		return;
	end
	if not THLM_Classes[overrideClass] then
		THLM_Print("Invalid class: "..overrideClass);
		return;
	end

	THLM_ClassOverrides[who] = {};
	THLM_ClassOverrides[who].name = who;
	THLM_ClassOverrides[who].class = overrideClass;
	THLM_Print("Class override set for "..who.." to "..overrideClass.." (".. THLM_Classes[overrideClass] ..").");
	if THLM_ResultFrame:IsVisible() then
		THLM_FixupBidClasses();
		THLM_UpdateResultDisplay();
	end
end

function THLM_FixupBidClasses()
    table.foreach(THLM_ResultList, function(k,v)
		v.class = THLM_GetClass(v.name, v.baseclass);
		if not v.class then
			v.class = v.baseclass;
		end
    end);
end

function THLM_ProcessBid(msg, who)
    local _, _, n = string.find(msg, "bid (%d+)");
    if not n then
        _, _, n = string.find(msg, "(%d+)");
    end
    if n and tonumber(n) then
		local baseClass = nil;
        local className = nil;
        local x;
        local numRaidMembers = GetNumRaidMembers();
        for x=1, numRaidMembers do
            local thisName, _, _, _, thisClass = GetRaidRosterInfo(x);
            if thisName == who then
			    baseClass = thisClass;
                className = THLM_GetClass(who, thisClass);
                x = numRaidMembers;
            end
        end
        if not className then
            return;
        end
        THLM_ResultList[who] = {};
        THLM_ResultList[who]["bid"] = tonumber(n);
        THLM_ResultList[who]["class"] = className;
        THLM_ResultList[who]["baseclass"] = baseClass;
        THLM_ResultList[who]["name"] = who;
        THLM_UpdateResultDisplay();
    end
end

function THLM_IsRunningAuction()
	if (THLM_CurrentItem and
    		THLM_CurrentAuctioneer == UnitName("player")) then
		return 1;
	else
		return nil;
	end
end

function THLM_OnEventServer(event)
    if (event=="CHAT_MSG_WHISPER") then
        local whisperMsg = arg1;
        local whisperFrom = arg2;
        if (THLM_IsRunningAuction()) then
            local x;
            local numRaidMembers = GetNumRaidMembers();
            for x=1, numRaidMembers do
                if UnitName("raid"..x) == whisperFrom then
                    THLM_ProcessBid(whisperMsg, whisperFrom);
                end
            end
        end
    elseif (event=="LOOT_OPENED") then
        THLM_ToggleLootButtons();
    elseif (event=="LOOT_CLOSED") then
        THLM_RunBid1:Hide();
        THLM_RunBid2:Hide();
        THLM_RunBid3:Hide();
        THLM_RunBid4:Hide();
    elseif (event=="LOOT_SLOT_CLEARED") then
        THLM_ToggleLootButtons();
    end
end

function THLM_OnLoadServer()
    this:RegisterEvent("LOOT_OPENED");
    this:RegisterEvent("LOOT_CLOSED");
    this:RegisterEvent("LOOT_SLOT_CLEARED");

    this:RegisterEvent("CHAT_MSG_WHISPER");

    SLASH_THLMTEST1 = "/thauc";
    SlashCmdList["THLMTEST"] = function(msg)
        if (not UnitInRaid("player")) then
            THLM_Print("You must be in a raid to do that!");
        elseif (THLM_GetRaidRank(UnitName("player")) >= 1) then
            THLM_StartBidOnItem(msg);
        else
            THLM_Print("You must be leader or promoted to do that!");
        end
    end

	SLASH_THLMSETCLASS1 = "/thsetclass";
	SlashCmdList["THLMSETCLASS"] = function(msg)
		local _, _, who, class = string.find(msg, "(%w+) (%w+)");
		if who and class then
			THLM_SetOverrideClass(who, class);
		else
			THLM_Print("Usage:  /thsetclass <playername> <class>");
		end
	end

	SLASH_THLMCLEARCLASS1 = "/thclearclass";
	SlashCmdList["THLMCLEARCLASS"] = function(msg)
		if msg then
			THLM_ClearOverrideClass(msg);
		else
			THLM_Print("Usage:  /thclearclass <playername>");
		end
	end
end
